/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ValidationRule type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ValidationRule{}

// ValidationRule struct for ValidationRule
type ValidationRule struct {
	Type *ValidationType `json:"type,omitempty"`
	Min *int32 `json:"min,omitempty"`
	Max *int32 `json:"max,omitempty"`
	// country code for zip code validation
	Country *string `json:"country,omitempty"`
	List []string `json:"list,omitempty"`
}

// NewValidationRule instantiates a new ValidationRule object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewValidationRule() *ValidationRule {
	this := ValidationRule{}
	return &this
}

// NewValidationRuleWithDefaults instantiates a new ValidationRule object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewValidationRuleWithDefaults() *ValidationRule {
	this := ValidationRule{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ValidationRule) GetType() ValidationType {
	if o == nil || IsNil(o.Type) {
		var ret ValidationType
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ValidationRule) GetTypeOk() (*ValidationType, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ValidationRule) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given ValidationType and assigns it to the Type field.
func (o *ValidationRule) SetType(v ValidationType) {
	o.Type = &v
}

// GetMin returns the Min field value if set, zero value otherwise.
func (o *ValidationRule) GetMin() int32 {
	if o == nil || IsNil(o.Min) {
		var ret int32
		return ret
	}
	return *o.Min
}

// GetMinOk returns a tuple with the Min field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ValidationRule) GetMinOk() (*int32, bool) {
	if o == nil || IsNil(o.Min) {
		return nil, false
	}
	return o.Min, true
}

// HasMin returns a boolean if a field has been set.
func (o *ValidationRule) HasMin() bool {
	if o != nil && !IsNil(o.Min) {
		return true
	}

	return false
}

// SetMin gets a reference to the given int32 and assigns it to the Min field.
func (o *ValidationRule) SetMin(v int32) {
	o.Min = &v
}

// GetMax returns the Max field value if set, zero value otherwise.
func (o *ValidationRule) GetMax() int32 {
	if o == nil || IsNil(o.Max) {
		var ret int32
		return ret
	}
	return *o.Max
}

// GetMaxOk returns a tuple with the Max field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ValidationRule) GetMaxOk() (*int32, bool) {
	if o == nil || IsNil(o.Max) {
		return nil, false
	}
	return o.Max, true
}

// HasMax returns a boolean if a field has been set.
func (o *ValidationRule) HasMax() bool {
	if o != nil && !IsNil(o.Max) {
		return true
	}

	return false
}

// SetMax gets a reference to the given int32 and assigns it to the Max field.
func (o *ValidationRule) SetMax(v int32) {
	o.Max = &v
}

// GetCountry returns the Country field value if set, zero value otherwise.
func (o *ValidationRule) GetCountry() string {
	if o == nil || IsNil(o.Country) {
		var ret string
		return ret
	}
	return *o.Country
}

// GetCountryOk returns a tuple with the Country field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ValidationRule) GetCountryOk() (*string, bool) {
	if o == nil || IsNil(o.Country) {
		return nil, false
	}
	return o.Country, true
}

// HasCountry returns a boolean if a field has been set.
func (o *ValidationRule) HasCountry() bool {
	if o != nil && !IsNil(o.Country) {
		return true
	}

	return false
}

// SetCountry gets a reference to the given string and assigns it to the Country field.
func (o *ValidationRule) SetCountry(v string) {
	o.Country = &v
}

// GetList returns the List field value if set, zero value otherwise.
func (o *ValidationRule) GetList() []string {
	if o == nil || IsNil(o.List) {
		var ret []string
		return ret
	}
	return o.List
}

// GetListOk returns a tuple with the List field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ValidationRule) GetListOk() ([]string, bool) {
	if o == nil || IsNil(o.List) {
		return nil, false
	}
	return o.List, true
}

// HasList returns a boolean if a field has been set.
func (o *ValidationRule) HasList() bool {
	if o != nil && !IsNil(o.List) {
		return true
	}

	return false
}

// SetList gets a reference to the given []string and assigns it to the List field.
func (o *ValidationRule) SetList(v []string) {
	o.List = v
}

func (o ValidationRule) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ValidationRule) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.Min) {
		toSerialize["min"] = o.Min
	}
	if !IsNil(o.Max) {
		toSerialize["max"] = o.Max
	}
	if !IsNil(o.Country) {
		toSerialize["country"] = o.Country
	}
	if !IsNil(o.List) {
		toSerialize["list"] = o.List
	}
	return toSerialize, nil
}

type NullableValidationRule struct {
	value *ValidationRule
	isSet bool
}

func (v NullableValidationRule) Get() *ValidationRule {
	return v.value
}

func (v *NullableValidationRule) Set(val *ValidationRule) {
	v.value = val
	v.isSet = true
}

func (v NullableValidationRule) IsSet() bool {
	return v.isSet
}

func (v *NullableValidationRule) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableValidationRule(val *ValidationRule) *NullableValidationRule {
	return &NullableValidationRule{value: val, isSet: true}
}

func (v NullableValidationRule) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableValidationRule) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


